#Meng Lu created on 2020/Aug/28
# In this script, we are going to subset your BEAST tree (which includes
# all theoutgroups) to keep Crassula ingroups only
# the obtained new ingourp-only tree will be used for all the downstream
# diversification analyses.
# Two methods are introduced; pick one you like :)

setwd("***set to your own file path")
getwd()

library(ape)
library(geiger)
library(phytools)
library(phangorn)

##read orginal tree##
wholetree <- read.nexus("BEAST_ITS_all.tre")


##------Tree Extraction------##
#-Method 1-#
#-Extraction Accroding to an Existing List-#

##read target taxa list
#read in table
subtree <- read.delim("Species_List_ingroup.txt", header= FALSE)
#change the table into a vector
subtree_taxa <-as.matrix(subtree)[,1]

##create the pruned tree
subtree.tree <- keep.tip(wholetree,subtree_taxa)
plotTree(subtree.tree,ftype="i")

##save your extracted tree
write.tree(subtree.tree, file = "BEAST_tree_cha.tre")


#-Method 2-#
#-Subsetting Accroding to a Tree Node-#

##find the node label by plotting tree
class(wholetree)
plot(wholetree, cex=0.3)
nodelabels(cex=0.3) 

#prune your tree according to your last result
Tree_no_outgp <-extract.clade(wholetree, node=210)
plot(Tree_no_outgp)

##save your extracted tree
write.tree(Tree_no_outgp, file = "BEAST_tree_cha.tre")


